
/**
 * Модуль для  раздела "списков рассылки".
 */

var history = (function () {
  return {

    wysiwyg: null, // HTML редактор для   редактирования страниц
    /**
     * Инициализирует обработчики для кнопок и элементов раздела.
     */
    init: function() {   
   
      // Вызов модального окна при нажатии на к
      // нопку добавления товаров.
      $('body').on('click', '.section-history .add-new-button', function(){
        history.openModalWindow('add');
      });
      
      $('body').on('click', '#modal-history .dde-modal-save', function(){
          history.saveList('');
      });
      
	  
      
    },


    /**
     * Открывает модальное окно.
     * type - тип окна, либо для создания нового товара, либо для редактирования старого.
     */
    openModalWindow: function(type, id) {



      switch (type) {
        case 'edit':{
          history.clearFileds();
          $('.remodal-header').text('Редактирование списка');
          history.editProduct(id);
         // $('.save-button').attr('id',response.data.id);
          break;
        }
        case 'add':{

          $('.remodal-headern').text('Добавление нового списка');
          history.clearFileds();        

          break;
        }
        default:{
          history.clearFileds();
          break;
        }
      }

      if(history.wysiwyg){
         history.wysiwyg.removeInstance('historyEditor');
         history.wysiwyg = null;
      }
      // Вызов модального окна.
     // admin.openModal($('.b-modal'));
      $('#modal-history').foundation('reveal','open');   

      history.wysiwyg = new nicEditor({maxHeight: 230, fullPanel : true}).panelInstance('historyEditor');

    },

 
    /**
     *  Проверка заполненности полей, для каждого поля прописывается свое правило.
     */
    checkRulesForm: function() {
      $('.errorField').css('display','none');
      $('.product-text-inputs input').removeClass('error-input');
      var error = false;

      // наименование не должно иметь специальных символов.
      if(!admin.regTest(1, $('.product-text-inputs input[name=title]').val()) || !$('.product-text-inputs input[name=title]').val()){
        $('.product-text-inputs input[name=title]').parent("label").find('.errorField').css('display','block');
        $('.product-text-inputs input[name=title]').addClass('error-input');
        error = true;
      }

      // наименование не должно иметь специальных символов.
      if(!admin.regTest(2, $('.product-text-inputs input[name=url]').val()) || !$('.product-text-inputs input[name=url]').val()){
        $('.product-text-inputs input[name=url]').parent("label").find('.errorField').css('display','block');
        $('.product-text-inputs input[name=url]').addClass('error-input');
        error = true;
      }

      // артикул обязательно надо заполнить.
      if(!$('.product-text-inputs input[name=code]').val()){
        $('.product-text-inputs input[name=code]').parent("label").find('.errorField').css('display','block');
        $('.product-text-inputs input[name=code]').addClass('error-input');
        error = true;
      }

      // Проверка поля для стоимости, является ли текст в него введенный числом.
      if(isNaN(parseFloat($('.product-text-inputs input[name=price]').val()))){
        $('.product-text-inputs input[name=price]').parent("label").find('.errorField').css('display','block');
        $('.product-text-inputs input[name=price]').addClass('error-input');
        error = true;
      }

      // Проверка поля количество, является ли текст в него введенный числом.
      if(isNaN(parseFloat($('.product-text-inputs input[name=count]').val()))){
        $('.product-text-inputs input[name=count]').parent("label").find('.errorField').css('display','block');
        $('.product-text-inputs input[name=count]').addClass('error-input');
        error = true;
      }

      if(error == true){
        return false;
      }

      return true;
    },


    /**
     * Сохранение изменений в модальном окне
     * Используется и для сохранения редактированных данных
     * id - идентификатор списка 
     */
    saveList: function(id) {

      // Если поля не верно заполнены, то не отправляем запрос на сервер.
      if(!history.checkRulesForm()){
      //  return false;
      }

      // Пакет характеристик .
      var packedProperty = {
        mguniqueurl:"action/savehistory",
        title: $('#modal-history input[name=title]').val(),
        content: $('.nicEdit-main').html(), 
      
      }
   

      // отправка данных на сервер для сохранения
      admin.ajaxRequest(packedProperty,
        function(response) {
          admin.indication(response.status, response.msg);

          admin.refreshPanel();

          // Закрываем окно    
          $('#modal-history').foundation('reveal','close');  
        }
      );
    },

    /**
     * изменяет строки в таблице товаров при редактировании изменении.
     */
    drawRow: function(element) {
          // html верстка для  записи в таблице раздела
          var row='\
            <tr id="'+element.id+'">\
              <td class="id">'+element.id+'</td>\
              <td class="product-picture image_url">\
                <img class="uploads" src="'+src+'"/>\
              </td>\
              <td class="name">'+element.title+'</td>\
              <td class="code">'+element.code+'</td>\
              <td class="price">'+element.price+'</td>\
              <td>'+element.count+'</td>\
              <td cat_id="'+element.cat_id+'" class="cat_id">'+cat_name+'</td>\
              <td><span class="'+classForTagActivity+'">'+element.activity+'</span></td>\
              <td class="actions">\
                <ul class="action-list">\
                  <li class="edit-row" id="'+element.id+'"><a href="#" title="'+lang.EDIT+'"></a></li>\
                  <li class="clone-row" id="'+element.id+'"><a href="#" title="'+lang.CLONE+'"></a></li>\
                  <li class="delete-order" id="'+element.id+'"><a href="#"  title="'+lang.DELETE+'"></a></li>\
                </ul>\
              </td>\
           </tr>';

         return row;
    },

    /**
     * Получает данные о продукте с сервера и заполняет ими поля в окне.
     */
    editProduct: function(id) {
      admin.ajaxRequest({
        mguniqueurl:"action/getProductData",
        id: id
      },
      history.fillFileds()
      );
    },


    /**
     * Удаляет список из БД сайта и таблицы в текущем разделе
     */
    deleteProduct: function(id,imgFile) {
      if(confirm(lang.DELETE+'?')){
        admin.ajaxRequest({
          mguniqueurl:"action/deleteProduct",
          id: id,
          imgFile: imgFile,
          msgImg: true
        },
        (function(response) {
          admin.indication(response.status, response.msg);
          $('.product-table tr[id='+id+']').remove();
            if($(".product-table tr").length==1){
                var html ='<tr class="no-results">\
                <td colspan="9" align="center">'+lang.PROD_NONE+'</td>\
               </tr>';
              $(".product-table").append(html);
            };
          })
        );
      }

    },


   /**
    * Заполняет поля модального окна данными
    */
    fillFileds:function() {
      return (function(response) {
        $('.product-text-inputs input').removeClass('error-input');
        $('.product-text-inputs input[name=title]').val(response.data.title);
        $('.product-text-inputs input[name=code]').val(response.data.code);
        $('.product-text-inputs input[name=price]').val(response.data.price);
        $('.product-text-inputs input[name=count]').val(response.data.count);
        $('.product-text-inputs select[name=cat_id]').val(response.data.cat_id);
        $('.product-text-inputs input[name=url]').val(response.data.url);

        var src=admin.SITE+'/mg-admin/design/images/no-img.png';
        if(response.data.image_url){
          src=admin.SITE+'/uploads/'+response.data.image_url;
        }


        $('.prev-img').html('<img src="'+src+'" alt="" />');
        $('.activity option[value="'+response.data.activity+'"]').prop("selected", "selected");
        $('.product-desc-wrapper .nicEdit-main').html(response.data.description);
        $('.seo-wrapper input[name=meta_title]').val(response.data.meta_title);
        $('.seo-wrapper input[name=meta_keywords]').val(response.data.meta_keywords);
        $('.seo-wrapper textarea[name=meta_desc]').val(response.data.meta_desc);
        $('.save-button').attr('id',response.data.id);
        $('.cancel-img-upload').attr('id',response.data.id);
        $('.userField').html('');

        try{
          $('.symbol-count').text($('.seo-wrapper textarea[name=meta_desc]').val().length);
        }catch(e){
          $('.symbol-count').text('0');
        }

        history.generateUserProreprty(response.data.id, response.data.cat_id);


      })
    },


   /**
    * Чистит все поля модального окна
    */
    clearFileds:function() {


      $('.product-text-inputs input[name=title]').val('');
      $('.product-text-inputs input[name=url]').val('');
      $('.product-text-inputs input[name=code]').val('');
      $('.product-text-inputs input[name=price]').val('');
      $('.product-text-inputs input[name=count]').val('');
      $('.product-text-inputs select[name=cat_id]').val('');
      $('.prev-img').html('<img src="'+admin.SITE+'/mg-admin/design/images/no-img.png" alt="" />');
      $('.product-desc-wrapper .nicEdit-main').html('');
      $('.seo-wrapper input[name=meta_title]').val('');
      $('.seo-wrapper input[name=meta_keywords]').val('');
      $('.seo-wrapper textarea[name=meta_desc]').val('');
      $('.userField').html('');
      $('.symbol-count').text('0');
      $('.save-button').attr('id','');

      // получаем с сервера все доступные пользовательские параметры
      admin.ajaxRequest({
         mguniqueurl:"action/getUserProperty"
       },
       function(response) {
          // выводим поля для редактирования пользовательских характеристик
          admin.indication(response.status, response.msg);
          userProperty.createUserFields(null,response.data.allProperty);
        }
       );

      // Стираем все ошибки предыдущего окна если они были.
      $('.errorField').css('display','none');

    },


    getProductByFilter: function(){

       var request = $("form[name=filter]").formSerialize();
       admin.show("history.php","adminpage",request);
       return false;

    }



  }
})();

// инициализациямодуля при подключении
history.init();

